%CREDITS: University of Bologna
%Author : Giovanni Mariotta


RGB=evalin('base','RGB');

soglia_focus = get(handles.slider3,'value');
    if soglia_focus == 0 
            soglia_focus =0.10;
        else
    end

assignin('base','soglia_efficienza',soglia_focus);

%Conversione da _RGB a Bianco Nero
J = rgb2gray(RGB);
RGB_color=evalin('base','RGB_color;');


%Filtraggio e Normalizzazione Sfondo considerando
%cluster di tipo ovali
I2 = imtophat(RGB_color, strel('disk', 10));
%figure(5);  imshow (RGB_color); title('Bianco e Nero Sfumato');

%-------------------------------------
% RILEVAZIONE 1/0 PRESENZA BATTERIO
%-------------------------------------

%level = graythresh(I2)
level=0.05;
BinaryBW = im2bw(I2,level);
BinaryBW_original = BinaryBW;

s=0;
p=0;

RGB_Red=RGB(:,:,1);
RGB_Green=RGB(:,:,2);
RGB_Blu=RGB(:,:,3);
dimensRGB=size(RGB);

assignin('base','stop_var',0);
stop=evalin('base','stop_var');


for i = 1 :(dimensRGB(1,1)-1)

stop=evalin('base','stop_var');

if stop == 1
    break;
end
    
    for k = 1 : (dimensRGB(1,2)-1)
    
        if stop == 1
        break;
        end
           
            if BinaryBW(i,k)==1 && BinaryBW(i,k+1)==0 || BinaryBW(i,k)==0 && BinaryBW(i,k+1)==1
                
                                
            %Prima di uscire dalla detezione del batterio si raggruppano i
            %pixel di esso in modo da eliminarli per la successiva
            %scansione
           
            p=p+1;
            index=find(BinaryBW(i,:));
            
            J        = regiongrowing(BinaryBW,i,index(1,1),0.2);
          
            element = find(J);   %% Contiene indice pixels di un Batterio o + se ho intersezioni
            
            index_inizio_cluster(p,1)=i;
            index_inizio_cluster(p,2)=index(1,1);     %CONTIENE COORDINATE X,Y del primo pixel rilevato come batterio
            area(p,1)=length(element);
            
            
            
                %----------------------------------
                %     ANALISI BATTERIO / REPORT
                %----------------------------------
            %Su element ho l'indirizzo lineare della BinaryBW originale
            %sulla quale leggere i dati di fluorescenza e fare media  e
            %deviazione standard.
            
            [m,n]= size(element);
            
                %Inizializzazione Bacterium_Color per ogni ciclo- contiene
                %gli indici pixel che appartengono a un batterio aggiornato
                %al successivo con il ciclo successivo
                
                Bacterium_Color_Red   = [0];
                Bacterium_Color_Green = [0];
                Bacterium_Color_Blu   = [0];
            
            
            for kappa=1:m
                
                %Genero un array per ciascun canale colore appartenente a
                %un batterio.
                
                Bacterium_Color_Red(kappa,1)  = RGB_Red(element(kappa));
                Bacterium_Color_Green(kappa,1)= RGB_Green(element(kappa));
                Bacterium_Color_Blu(kappa,1)  = RGB_Blu(element(kappa));
                
                            
            end
                
            
                    %--------------------------------------
                    %                REPORT
                    %--------------------------------------
                    
            
               
            %Matrice Report per media e deviazione standard su ogni canale 
            %colore  
                           
             Report_Mean_STD(p,1) = mean(Bacterium_Color_Red(:,1));
             Report_Mean_STD(p,2) = mean(Bacterium_Color_Green(:,1));
             Report_Mean_STD(p,3) = mean(Bacterium_Color_Blu(:,1));
             
             
             Report_Mean_STD(p,5) = std(Bacterium_Color_Red(:,1));
             Report_Mean_STD(p,6) = std(Bacterium_Color_Green(:,1));
             Report_Mean_STD(p,7) = std(Bacterium_Color_Blu(:,1));
             
             assignin('base','Report_Mean_STD',Report_Mean_STD);
             
             
            %Report globale per gaussiana basata sul livello fluorescenza 
            %Green, Red, Blu
            
         
             
              % ----------------------------------------------------------------
              % Continuazione elaborazione eliminando dall'immagine il batterio 
              % gi processato             
              % ---------------------------------------------------------------- 
              BinaryBW =(BinaryBW-J);
              s=s+1; %Incremento indice per l'elemento batterio successivo
              axes(handles.axes2);
              imshow(BinaryBW)
              
 
            end
            
       
          
    end
    
      
    percentuale =  round((i /959 )*100);
    set(handles.text_Percentuale, 'String',percentuale)
  
end



if stop == 0
    

    
assignin('base','area_clusters',area);


% ------------------------------------------
% Eliminazione Popolazione non significativa
% ------------------------------------------


%boxplot(area(:,1))
    % **********
    % TEST AREA
    % **********


    percentile_popol =prctile(area(:,1),[25 75]);  %Calcolo primo percentile e terzo percentile
    
    limite_area_inf = get(handles.slider4,'value');
    limite_area_sup = get(handles.slider5,'value');


if limite_area_inf > 0 && limite_area_sup > 0
    
    percentile_popol(1,1) = limite_area_inf;
    percentile_popol(1,2) = limite_area_sup;
    
else
    
    limite_area_inf = percentile_popol(1,1);
    limite_area_sup = percentile_popol(1,2)+1.5*iqr(area(:,1));
    
end
    
    for i = 1 :length(area)
    
      if area(i,1) > limite_area_inf && area(i,1) < limite_area_sup
       
            area(i,2)=1;
            Report_Mean_STD(i,10)=1;
      else
            area(i,2)=0;
            Report_Mean_STD(i,10)=0;
      end
    
    end

campioni_area_ok=find(area(:,2)); %Vettore con indici elementi che passano il test

for i=1:length(campioni_area_ok)
    
    media_test_area_ok(i,1)=Report_Mean_STD(campioni_area_ok(i,1),2);
end

    % *************
    % TEST STD/MEAN
    % *************
    

     for i=1:length(Report_Mean_STD)
         focus(i,1) = Report_Mean_STD(i,6)./Report_Mean_STD(i,2);  
     end
     
    
    
    
    for i = 1 :length(focus)
    
         if focus(i,1) < soglia_focus
       
             focus(i,2)=1;
             Report_Mean_STD(i,11)=1;
         else
             focus(i,2)=0;
             Report_Mean_STD(i,11)=0;
         end
    end
    
   
   Report_Mean_STD(:,13)= Report_Mean_STD(:,10) & Report_Mean_STD(:,11);
   
   indice_TOT_TEST_OK=find(Report_Mean_STD(:,13));
   
   for i= 1: length(indice_TOT_TEST_OK)
       
       elementi_test_OK(i,1) = Report_Mean_STD(indice_TOT_TEST_OK(i,1),2);
       assignin('base','elementi_test_OK',elementi_test_OK)
   end
       
   % elementi_test_OK contiene le medie di tutti i cluster che sono
   % sopravvisuti ai test
   
   evalin('base','clc');
   
   media               = mean(elementi_test_OK(:,1));
   mediana             = median(elementi_test_OK(:,1));
   deviazione_standard = std(elementi_test_OK(:,1));
   minimo              = min(elementi_test_OK(:,1));
   massimo             = max(elementi_test_OK(:,1));
    
   
   assignin('base','mediana',             median(elementi_test_OK(:,1)))
   assignin('base','media',               mean(elementi_test_OK(:,1)))
   assignin('base','deviazione_standard', std(elementi_test_OK(:,1)))
   assignin('base','minimo',              min(elementi_test_OK(:,1)))
   assignin('base','massimo',             max(elementi_test_OK(:,1)))
   
  
   
   evalin('base','mediana')
   evalin('base','media')
   evalin('base','deviazione_standard')
   evalin('base','minimo')
   evalin('base','massimo')
   
   set(handles.text1_R, 'String', media)
   set(handles.text2_R, 'String', deviazione_standard)
   set(handles.text3_R, 'String', mediana)
   set(handles.text4_R, 'String', minimo)
   set(handles.text5_R, 'String', massimo)
   set(handles.text6_R, 'String', p)
   set(handles.text7_R, 'String', length(indice_TOT_TEST_OK))
   
   
%    
% %Recolor con  valore medio
%       

       RGB_Green_recolor= RGB_Green;
       RGB_Green_recolor_Bianco = RGB_Green;
       recolor_index = find(Report_Mean_STD(:,13));
        
       for i = 1:length(recolor_index)
       
       Jrecolor  = regiongrowing(BinaryBW_original,index_inizio_cluster(recolor_index(i,1),1),index_inizio_cluster(recolor_index(i,1),2),0.2);
       element_recolor = find(Jrecolor);
       
       
       
            for q = 1:length(element_recolor)
           
                  RGB_Green_recolor(element_recolor(q,1))= Report_Mean_STD(recolor_index(i,1),2);
                 RGB_Green_recolor_Bianco(element_recolor(q,1))=255;
            end
            

       end   
       
     %       figure(1)       
     %imshow(RGB_Green_recolor)
     RGBCOLOR=RGB;
     RGBCOLOR(:,:,2)=RGB_Green_recolor;
     
     DifferenzaGreen=(RGB(:,:,2)-RGB_Green_recolor);
     RGBrec=RGB;
     RGBrec(:,:,2)=DifferenzaGreen*10;
     
     
     
     axes(handles.axes2);
     
     %imshow(RGBCOLOR)
     %mshow(RGBrec)
     %figure(3)
     imshow(RGB_Green_recolor_Bianco)
     
     
     axes(handles.axes3);
     cla reset
     hist(area(:,1),30);
     massimo_hist= max(hist(area(:,1),30));
     hold on
     y=[0:0.1:massimo_hist+10];
     for i=1: length(y)
         
         arealimit(i,1)=limite_area_inf;
     end
     
     plot(arealimit,y);
     
     for i=1: length(y)
         
         arealimit(i,1)=limite_area_sup;
     end
     
      plot(arealimit,y);
     
     
     
     set(handles.text_Limite_Inferiore_Alg, 'String', percentile_popol(1,1))
     set(handles.text_Limite_Superiore_Alg, 'String', percentile_popol(1,2)+1.5*iqr(area(:,1)))
     

  
else
end

            
            
            
            
            
    